uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projMatrix;

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec4 inColor;
layout(location = 2) in vec2 inTexCoord;
layout(location = 3) in vec3 inNormal;

out vec2 texCoord;

void main(void)
{
    texCoord = inTexCoord;
    mat4 modelView = viewMatrix * modelMatrix;
    vec4 viewPos = modelView * vec4(inPosition, 1.0);
    
    gl_Position	= projMatrix * viewPos;
}