uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projMatrix;
uniform mat4 texMatrix;

layout(location = 0) in vec3 inPosition;
layout(location = 1) in vec4 inColor;
layout(location = 2) in vec2 inTexCoord;
layout(location = 3) in vec3 inNormal;
layout(location = 4) in vec3 inTangent;
layout(location = 5) in vec3 inBitangent;

out vec3 worldPos;
out vec3 viewPos;
out vec3 worldNormal;
out vec3 viewNormal;

void main(void)
{
    worldPos = (modelMatrix * vec4(inPosition, 1.0)).xyz;
    viewPos = (viewMatrix * vec4(worldPos, 1.0)).xyz;

    mat3 worldNormalMatrix = transpose(inverse(mat3(modelMatrix)));
    mat3 viewNormalMatrix = transpose(inverse(mat3(viewMatrix * modelMatrix)));
    worldNormal = normalize(worldNormalMatrix * inNormal);
    viewNormal = normalize(viewNormalMatrix * inNormal);
    gl_Position	= projMatrix * vec4(viewPos, 1.0);
}