uniform sampler2D texDiffuse;

in vec3 position;
in vec3 worldPos;
in vec3 viewPos;
in vec2 texCoord;
in vec3 normal;
in vec3 tangent;
in vec3 bitangent;

layout(location = 0) out vec4 outGPosition;
layout(location = 1) out vec4 outGNormal;
layout(location = 2) out vec4 outGAlbedo;
layout(location = 3) out vec4 outGMaterial;

uniform vec4 objectColor;

uniform bool lightingEnabled;

void main (void)
{
    // Viewspace position to position texture
    outGPosition = vec4(viewPos, 1.0);

    // Viewspace normal and specular power to normal/specular texture
    outGNormal = vec4(normal, 1.0);

    // Albedo color to albedo texture
    outGAlbedo = objectColor;

    // Lighting enable flag to material buffer
    outGMaterial.r = lightingEnabled ? 1.0 : 0.0;

    // Specular power to material buffer
    outGMaterial.g = 1.0;
    outGMaterial.a = 1.0;
}