uniform sampler2D texDiffuse;
uniform sampler2D texSpecial1;


in vec3 tesWorldPos;
in vec3 tesViewPos;
in vec2 tesTexCoord;
in vec3 tesNormal;
in vec3 tesTangent;
in vec3 tesBitangent;

layout(location = 0) out vec4 outGPosition;
layout(location = 1) out vec4 outGNormal;
layout(location = 2) out vec4 outGAlbedo;
layout(location = 3) out vec4 outGMaterial;

uniform bool lightingEnabled;

void main (void)
{
    // Color
    vec4 diffuseColor = texture(texDiffuse, tesTexCoord);
    if (diffuseColor.a < 0.3)
       discard;
       
    // Viewspace position to position texture
    outGPosition = vec4(tesViewPos, 1.0);

    // Viewspace normal and specular power to normal/specular texture
    outGNormal = vec4(tesNormal, 1.0);

    // Albedo color to albedo texture
    outGAlbedo = diffuseColor;

    // Lighting enable flag to material buffer
    outGMaterial.r = lightingEnabled ? 1.0 : 0.0;

    // Specular power to material buffer
    outGMaterial.g = 0.2;//texture(texSpecular, texCoord).r;
    outGMaterial.a = 1.0;
}