layout (vertices = 3) out;

in vec3 vsWorldPos[];
in vec3 vsViewPos[];
in vec2 vsTexCoord[];
in vec3 vsNormal[];
in vec3 vsTangent[];
in vec3 vsBitangent[];

out vec3 tcsWorldPos[];
out vec3 tcsViewPos[];
out vec2 tcsTexCoord[];
out vec3 tcsNormal[];
out vec3 tcsTangent[];
out vec3 tcsBitangent[];

void main() {
	// Specifiy enough subdivisions to suit the detailed level of the bricks
	gl_TessLevelInner[0] = 256;

	gl_TessLevelOuter[0] = 128;
	gl_TessLevelOuter[1] = 128;
	gl_TessLevelOuter[2] = 128;

	tcsWorldPos[gl_InvocationID] = vsWorldPos[gl_InvocationID];
	tcsViewPos[gl_InvocationID] = vsViewPos[gl_InvocationID];
	tcsTexCoord[gl_InvocationID] = vsTexCoord[gl_InvocationID];
	tcsNormal[gl_InvocationID] = vsNormal[gl_InvocationID];
	tcsTangent[gl_InvocationID] = vsTangent[gl_InvocationID];
	tcsBitangent[gl_InvocationID] = vsBitangent[gl_InvocationID];

	gl_out[gl_InvocationID].gl_Position = gl_in[gl_InvocationID].gl_Position;
}