
layout(triangles) in;

// Outputting 18 vertices (3 per triangle * 6 per cubemap face)
layout(triangle_strip, max_vertices = 18) out;

// Matrices to transform from world space position to cubemap face i
uniform mat4 cubeMatrices[6];

out vec4 worldPos;

void main(void)
{
    // gl_Layer lets us select cubemap faces
    for (gl_Layer = 0; gl_Layer < 6; ++gl_Layer)
    {
        // For each trangle vertex
        for (int i = 0; i < 3; ++i)
        {
            // Take worldspace vertex
            worldPos = gl_in[i].gl_Position;

            // ...and transform it into view space
            gl_Position = cubeMatrices[gl_Layer] * worldPos;

            EmitVertex();
        }

        EndPrimitive();
    }
}